<template>
    <div class="timer-app">
        <modal  v-if="showModal" @clicked="clicked"></modal>
        <!-- HEADER BEGIN -->
        <div class="app-header">
            <div class="top-app">
                <span v-on:click="goProfile" class="icon-user profile"></span>
                <h1 class="title">JIRA Stopwatch</h1>
                <span v-on:click="goSettings" class="icon-settings settings"></span>
            </div>
            <div class="timer-container">
                <div class="top">
                    <span v-on:click="shuffleCurrentTimer" v-bind:class="[currentTime.busy? 'icon-pause': 'icon-play' ,'action']"></span>
                    <label class="clock">{{ formatNumbers(currentTime.hours) }}:{{formatNumbers(currentTime.minutes) }} </label>
                    <span v-on:click="submitCurrentTimer" class="submit icon-check"></span>
                </div>
                <div class="current-task">
                    <img v-if="this.currentTime.busy" src="assets/timer.svg" alt="">
                    <h2> {{ currentTime.project }} </h2>
                    <h2>{{ currentTime.key}}  {{ formatText(currentTime.description,40) }} </h2>
                </div>
            </div>
            <div v-bind:class="[error.show? 'active-message': '' ,'info-messages']">
                <p>{{ error.message  }}</p>
            </div>
        </div>
        <!-- HEADER END -->
        <!-- BODY BEGIN -->
       
        <div class="app-tasks">
            <div class="task-grid">
                <!--tasks loop-->
                    <div v-for="(timer,index) in timers" v-bind:key="index" v-on:contextmenu="showMenu(timer.id)" class="task-item">
                        <div  v-bind:class="[timer.mode === 2?  'active-edit': timer.mode === 3?'active-empty':'' ,'task-container']">
                            <div class="item-container">
                                <div class="col-left-empty">
                                    <h3 v-on:click="searchForIssue(timer)" class="empty-option">Search issue</h3>
                                    <h3 class="empty-separator">- OR -</h3>
                                    <h3 v-on:click="enterKeyForIssue(timer)" class="empty-option">Enter key</h3>
                                </div>
                                <div class="col-right">
                                    <div class="controls">
                                        <span v-on:click="returnTimeMode(timer)" class="icon-back start-task"></span>
                                    </div>
                                    <span class="current-time"> {{ formatNumbers(timer.hours) }}:{{ formatNumbers(timer.minutes) }}</span>
                                </div>

                            </div>
                            <div class="item-container">
                                <div class="col-left">
                                    <h3 class="task-id">{{ timer.key }}</h3>
                                    <h2 class="task-name"> {{ formatText(timer.description,50) }}</h2>
                                </div>
                                <div class="col-right">
                                    <div class="controls">
                                        <span v-on:click="shuffleTimer(timer)" v-bind:class="[timer.currentTimer && currentTime.busy? 'icon-pause': 'icon-play' ,'start-task']" ></span>
                                        <span v-on:click="submitTimer(timer)" class="icon-check start-task"></span>
                                    </div>
                                    <span class="current-time"> {{ formatNumbers(timer.hours) }}:{{ formatNumbers(timer.minutes) }}</span>
                                </div>

                            </div>
                            <div class="item-container">
                                <div class="col-left-edit">
                                    <h3 class="task-id">{{ timer.key }}</h3>
                                    <h2 class="task-name"> {{ formatText(timer.description,30) }}</h2>
                                </div>
                                <div class="col-right-edit">
                                     <div>
                                         <input v-on:keypress="formatEditInput" placeholder="hh" class="editedHour" v-model="timer.editHours" type="text" >
                                         <span class="separator">:</span>
                                         <input v-on:keypress="formatEditInput" placeholder="mm" class="editedMinute" v-model="timer.editMinutes" type="text" >
                                     </div>
                                    <span v-on:click="editTimer(timer)" class="icon-check start-task"></span>
                                </div>
                            </div>
                        </div>
                    </div>
                <!--tasks loop-->
            </div>
        </div>
        <!-- BODY BEGIN -->
        
        <!-- FOOTER BEGIN -->

        <div class="app-new-task" v-bind:class="{ 'active-task':isNewTask}">
            <div class="task-search-input">
              <input v-on:keyup.enter="createTimer" v-model="newIssue" type="text" class="entry" placeholder="Issue">
              <span v-on:click="createTimer" class="entryLabel icon-add"></span>
            </div>
            <span v-on:click="createEmptyTimer" class="icon-timer empty-task-icon"></span>
        </div>
        <div class="app-footer">
            <span v-on:click="showNewTask" class="icon-add entry">New</span>
            <span v-on:click="openTaskSearch"  class="entry icon-search"></span>
            <label class="time-elapsed"> {{ formatNumbers(totalElapsed.hours) }}:{{ formatNumbers(totalElapsed.minutes) }}</label>
        </div>
        <!-- FOOTER END -->
        <!-- need declare this variables in the view to make it reactive, all computed variable needs to be here -->
        {{ successSubmit }}
        {{ successAddTask }}
        {{ searchKey }}
    </div>
</template>

<script>
    import Modal from './Modal'

    const {ipcRenderer} = window.require('electron')
    let interval
    let saveInternal

    // Class that make te count function
    let clsStopwatch = function () {
      // Private vars
      let startAt = 0 // Time of last start / resume  . (0 if not running)
      let lapTime = 0 // Time on the clock when last stopped in milliseconds

      let now = function () {
        return (new Date()).getTime()
      }

        // Public methods
        // Start or resume
      this.start = function (milliseconds) {
        startAt = !startAt ? now() - milliseconds : startAt
      }

        // Stop or pause
      this.stop = function () {
            // If running, update elapsed time otherwise keep it
        lapTime = startAt ? lapTime + now() - startAt : lapTime
        startAt = 0
      }

        // Reset
        this.reset = function() {
            lapTime = startAt = 0;
        };

        // Duration
        this.time = function() {
            return lapTime + (startAt ? now() - startAt : 0);
        };
    };

    let x = new clsStopwatch();


    export default {
      name: 'timer-page',
      components: { Modal },
      data: function () {
        return {
          timers: [],
          newTimer: {},
          newIssue: '',
          totalElapsed: {hours: 0, minutes: 0},
          currentTime: {hours: 0, minutes: 0, seconds: 0, busy: false, description: '', id: '', key: '', project: ''},
          currentSelectedItem: '',
          error: {show: false, message: ''},
          TIME_MODE: 1,
          EDIT_MODE: 2,
          EMPTY_MODE: 3,
          timerOfKey: 0,
          showModal:false,
          isNewTask: false,
          changeState:true
        }
      },
      computed: {
        // VUEX LISTENERS
        // This method is called from the submit view
        successSubmit () {
          let deleteBySubmit = this.$store.state.counters.timer.successSubmit
          let removeAfter = this.$store.state.counters.timer.removeAfter
          if (deleteBySubmit) {
              this.currentTime = {hours: 0, minutes: 0, seconds: 0, busy: false, description: '', id: '', key: '', project: ''}
              if(removeAfter){
                let timerIndex = this.timers.findIndex(x => x.id === this.$store.state.counters.timer.id)
                this.timers.splice(timerIndex, 1)
              }else{
                let timer = this.timers.find(x => x.id === this.$store.state.counters.timer.id)
                timer.hours = 0
                timer.minutes = 0
                timer.seconds = 0
                timer.busy = false
              }
            this.updateTimers()
            this.changeState = true
            this.$store.commit('CLEAR_VALUES')
          }
        },
        successAddTask(){
            let data = {title: this.$store.state.counters.new.title, description: this.$store.state.counters.new.description,success: this.$store.state.counters.new.successNewTask}
            if(data.success){
                let id = Math.floor(Math.random() * -1000000) - 1
                let existingTimer = this.timers.find(x => x.id === id)
                if (existingTimer) return;
                this.newTimer = {id: id, key: data.title, description: data.description, hours: 0, minutes: 0, seconds: 0,currentTimer: false, mode: this.TIME_MODE, project: '', editHours:'',editMinutes:''}
                this.timers.push(this.newTimer)
                this.newIssue = ''
                this.isNewTask = false
                this.changeState = true
                this.$store.commit('CLEAR_NEW')
            }
        },
        // this method is called form the search issues view
        searchKey () {
          let data = {key: this.$store.state.counters.search.key, id: this.$store.state.counters.search.id};
          if(data.key !== ''){
            this.newIssue = data.key
            this.changeState = true
            this.$store.commit('CLEAR_SEARCH')
            ipcRenderer.send('validate-issue', {key: data.key, timerId: data.id})
          }
        }
      },
      methods: {
        // gives the behavior to the edit input of the timer list 
        formatEditInput: function (evt) {
            let element = $(evt.target).attr('class');

            if(evt.target.value.length <= 2){
                let charCode = (evt.which) ? evt.which : evt.keyCode;
                if (charCode > 31 && (charCode < 48 || charCode > 57)) {
                    evt.preventDefault()
                }else{
                    if(evt.target.value.length === 2){
                        evt.target.value =  ''
                    }
                }
            }
        },
        // routing method, when is called the vue router call the profile view
        goProfile: function () {
          this.$router.push('profile')
        },
        // routing method, when is called the vue router call the settings view
        goSettings: function () {
          this.$router.push('settings')
        },
        // format method, set the leading zero to any text that use the function
        formatNumbers: function (number) {
          return ('0' + number).slice(-2)
        },
        // format method, remove text to fit the size of cutAt parameter and add ... at the end
        formatText: function (text,cutAt){
            return text.substr(0,cutAt-1)+(text.length>cutAt?'...':'');
        },
        // internal method, send to submit logic is triggered for the current timer
        submitCurrentTimer: function () {
          if (this.currentTime.id) {
            this.pauseTimer()
            // search the current timer in the timers list form manipulate it 
            let timer = this.timers.find(x => x.id === this.currentTime.id)
            //if the timer is in edit mode, send to complete the edit process
            if (timer.mode === this.EDIT_MODE) { this.editTimer(timer) }
            if (timer.id < 0 ) {
              timer.mode = this.EMPTY_MODE;
            } else {
              // call vuex action to pass the current timer to shared scope and call submit task view
              this.$store.commit('INSERT_VALUE', this.currentTime)
              this.$router.push('submit-task')
            }
          } else {
            this.showError('Please select a task first')
          }
        },
        // internal method, call backend nodejs to trigger the native contextual menu
        showMenu: function (itemId) {
          this.currentSelectedItem = itemId
          ipcRenderer.send('show-context-menu')
        },
        // internal method, logic that made the suffle of timer , if is paused will play, if is play will pause (timer list)
        shuffleTimer: function (timer) {
          let isBusy = false
          if (this.currentTime.busy === true) {
            this.saveCurrentTime()
            isBusy = true
          }
          if (String(this.currentTime.id) === String(timer.id) && isBusy === true) {
            this.pauseTimer()
          } else {
            this.startTimer(timer)
          }
        },
        // internal method, logic that made the suffle of timer , if is paused will play, if is play will pause (current timer)
        shuffleCurrentTimer: function () {
          if (this.currentTime.id) {
            if (this.currentTime.busy === true) {
              this.pauseTimer()
            } else {
              let timer = this.timers.find(x => x.id === this.currentTime.id)
              if (timer.mode === this.EDIT_MODE) { this.editTimer(timer) }
              this.startTimer(timer)
            }
          } else {
            this.showError('Please select a task first')
          }
        },
        // internal method, logic that edit the given timer, pass the edit timer values to current values and update current timer and global time
        editTimer: function (timer) {
            timer.minutes = timer.editMinutes
            timer.hours = timer.editHours
            timer.editHours = 0
            timer.editMinutes = 0
            timer.mode = this.TIME_MODE

            if(timer.id === this.currentTime.id){
                this.currentTime.minutes = timer.minutes;
                this.currentTime.hours = timer.hours;
            }
            let totalHours = this.timers.reduce((a, b) => Number(a) + Number(b.hours), 0)
            let totalMinutes = this.timers.reduce((a, b) => a + Number(b.minutes), 0)

            if (totalMinutes > 60) {
                totalHours = totalHours +  Math.floor(totalMinutes / 60)
                totalMinutes = totalMinutes % 60
            }
            this.totalElapsed.hours = totalHours
            this.totalElapsed.minutes = totalMinutes
        },
        // internal method, call the submit logic of the timer 
        submitTimer: function (timer) {
          // if the timer gives to submit is equal to the current timer pause the current timer
          if (timer.id === this.currentTime.id) {
            this.pauseTimer()
          }
          // if the timer id is minor to zero, is an empty timer (not sure if this is needed 8-) )
          if (timer.id < 0 ) {
              timer.mode = this.EMPTY_MODE;
          } else {
            // send the timer to vuex shared scope and call the submit task view
            this.$store.commit('INSERT_VALUE', timer)
            this.$router.push('submit-task')
          }
        },
        // internal method, start the send timer in zeros and change the status to inactive of the previus active timer
        startTimer: function (timer) {
          let previousTimer = this.timers.find(x => x.currentTimer === true && x.id != timer.id)
          if (previousTimer) {
            previousTimer.currentTimer = false
          }
          x.reset()
          let currentMiliseconds =   (timer.hours * (60000 * 60)) + (timer.minutes * 60000) + (timer.seconds * 1000)
          x.start(currentMiliseconds)
          interval = window.setInterval(this.countTime, 500)
          this.currentTime.id = timer.id
          this.currentTime.project = timer.project
          this.currentTime.description = timer.description
          this.currentTime.key = timer.key
          this.currentTime.busy = true
          timer.currentTimer = true
        },
        // internal method, activate the error div an display the given message
        showError: function (message) {
          let self = this
          self.error.show = true
          self.error.message = message

          setTimeout(function () {
            if (self.error.show === true) { self.error.show = false }
          }, 2000)
        },
        // internal method, puase the current timer function is called
        pauseTimer: function () {
          x.stop()
          clearInterval(interval)
          this.currentTime.busy = false
        },
        // internal method, called when shuffle between timers, to save the current timer spended time in the timers list
        saveCurrentTime: function () {
          let timer = this.timers.find(x => x.id === this.currentTime.id)
          timer.minutes = this.currentTime.minutes
          timer.hours = this.currentTime.hours
          timer.seconds = this.currentTime.seconds
        },
        // internal method, change the reactive variable to open the div where the input of new task is
        showNewTask: function () {
          if (!this.isNewTask) { this.isNewTask = true } else { this.isNewTask = false }
        },
        // internal method, call the search task view, the 1 value parameters is to specify that the search not belong to any task
        openTaskSearch: function () {
            this.$store.commit('INIT_SEARCH',1)
            this.$router.push('search-task')
        },
        // internal method, call to backend nodejs to validate the issue given by JIRA api and return his data
        createTimer: function () {
          ipcRenderer.send('validate-issue', {key:this.newIssue, timerId:1})
        },
        // internal method, create an empty timer without jira relationship and store into the timers list
        createEmptyTimer: function (){
            this.$router.push('new-task')


        },
        // internal method, use in interval function to take care of counting the time
        countTime: function () {
          if (this.currentTime.busy === true) {
            let time = x.time()
            this.currentTime.hours = Math.floor( time / (60 * 60 * 1000) )
            time = time % (60 * 60 * 1000);
            this.currentTime.minutes = Math.floor( time / (60 * 1000) )
            time = time % (60 * 1000);
            this.currentTime.seconds = Math.floor( time / 1000 )
            this.changeState = true
            this.updateTimers()
          }
        },
        // internal method, the only function of this is update the global time displayed at the end of the main view
        updateTimers () {
          let timer = this.timers.find(x => x.id === this.currentTime.id)
          if (timer) {
              timer.hours = this.currentTime.hours
              timer.minutes = this.currentTime.minutes
              timer.seconds = this.currentTime.seconds
          }
          let totalHours = this.timers.reduce((a, b) => Number(a) + Number(b.hours), 0)
          let totalMinutes = this.timers.reduce((a, b) => a + Number(b.minutes), 0)
            // separate hours and minutes from totalMinutes
            // add hours to totalHours
            // totalMinutes equals to remaining minutes from operation
          if (totalMinutes > 60) {
            totalHours = totalHours +  Math.floor(totalMinutes / 60)
            totalMinutes = totalMinutes % 60
          }
          this.totalElapsed.hours = totalHours
          this.totalElapsed.minutes = totalMinutes
        },
        returnTimeMode: function (timer) {
          timer.mode = this.TIME_MODE
        },
        searchForIssue: function (timer) {
          this.$store.commit('INIT_SEARCH', timer.id)
          this.$router.push('search-task')
        },
        enterKeyForIssue: function (timer) {
            this.timerOfKey = timer.id
            this.showModal = true
        },
        clicked: function (value) {
            let id = this.timerOfKey
            this.timerOfKey = 0;
            ipcRenderer.send('validate-issue', {key:value, timerId: id})
            this.showModal = false
        },
        saveState: function(){
            if(this.changeState){
                let stateSaved = ipcRenderer.sendSync('save-state', this.timers)
                this.changeState = false
            }
        }
      },
      activated: function(){
        let windowHeiht = $(window).height()
        $('.app-tasks').height(windowHeiht - 248)
        $('.task-grid').height(windowHeiht - 248)
      },
      created: function () {
        saveInternal = window.setInterval(this.saveState, 10000)
        // request timers that are saved in persist backend
        ipcRenderer.send('request-timers')
        // assign timers to reactive array for display them in view
        ipcRenderer.on('restore-timers', (event, arg) => {
          this.timers = arg
        })
        let self = this

        window.addEventListener('beforeunload', function (event) {
          let stateSaved = ipcRenderer.sendSync('save-state', self.timers)
        })
        // LISTENERS
        ipcRenderer.on('context-item-start', (event, arg) => {
          let timer = this.timers.find(x => x.id === this.currentSelectedItem)
          if (timer.mode === this.EDIT_MODE) { this.editTimer(timer) }
          this.shuffleTimer(timer)
        })
        ipcRenderer.on('context-item-submit', (event, arg) => {
          let timer = this.timers.find(x => x.id === this.currentSelectedItem)
          if (timer.mode === this.EDIT_MODE) { this.editTimer(timer) }
          this.submitTimer(timer)
        })
         ipcRenderer.on('context-item-external', (event, arg) => {
          let timer = this.timers.find(x => x.id === this.currentSelectedItem)
          if(timer.id > 0) {
            ipcRenderer.send('open-issue', timer.key)
          } else {
            this.showError('This timer is not from JIRA')
          }
        })
        ipcRenderer.on('context-item-edit', (event, arg) => {
          let timer = this.timers.find(x => x.id === this.currentSelectedItem)
          if (timer.id === this.currentTime.id && this.currentTime.busy) { this.pauseTimer() }
          if (timer.mode === this.EDIT_MODE) { timer.mode = this.TIME_MODE }
          else {
            timer.editHours   = this.formatNumbers(timer.hours)
            timer.editMinutes = this.formatNumbers(timer.minutes)
            timer.mode = this.EDIT_MODE
          }
        })
        ipcRenderer.on('context-item-choose', (event, arg) => {
          let timer = this.timers.find(x => x.id === this.currentSelectedItem)
          if(timer.mode === this.EMPTY_MODE)
            timer.mode = this.TIME_MODE
          else
            timer.mode = this.EMPTY_MODE

        })
        ipcRenderer.on('context-item-delete', (event, arg) => {
          if (String(this.currentTime.id) === String(this.currentSelectedItem)) {
            this.currentTime = {hours: 0, minutes: 0, seconds: 0, busy: false, description: '', id: '', key: '', project: ''}
          }
          let timer = this.timers.find(x => x.id === this.currentSelectedItem)
          if (timer.id === this.currentTime.id && this.currentTime.busy) { this.pauseTimer() }
          let timerIndex = this.timers.findIndex(x => x.id === this.currentSelectedItem)
          this.timers.splice(timerIndex, 1)
          this.updateTimers()
          this.changeState = true
        })


        ipcRenderer.on('pause-timer-due-idle', (event, arg) => {
          this.pauseTimer()
        })
        ipcRenderer.on('resume-timer-due-idle', (event, arg) => {
            if (this.currentTime.id) {
            if (this.currentTime.busy !== true) {
              let timer = this.timers.find(x => x.id === this.currentTime.id)
              if (timer.mode === this.EDIT_MODE) { this.editTimer(timer) }
              this.startTimer(timer)
            } 
          }
        })

        // response to validate-issue success and add one timer to the array of timers
        ipcRenderer.on('add-issue', (event, arg) => {
            console.log(arg)
          let existingTimer = this.timers.find(x => x.id === arg.data.id)
          if (existingTimer) {
            this.showError('This timer already exist')
          } else {
            if (arg.timerId === 1) {
              this.newTimer = {id: arg.data.id, key: arg.data.key, description: arg.data.fields.summary, hours: 0, minutes: 0, seconds: 0,currentTimer: false, mode: this.TIME_MODE, project: arg.data.fields.project.name, editHours:'',editMinutes:''}
              this.timers.push(this.newTimer)
            } else {
              let emptyTimer = this.timers.find(x => x.id === arg.timerId)
              if (!emptyTimer)return
              let previousTimerId = emptyTimer.id
              emptyTimer.id = arg.data.id
              emptyTimer.key = arg.data.key
              emptyTimer.description = arg.data.fields.summary
              emptyTimer.project = arg.data.fields.project.name
              emptyTimer.mode = this.TIME_MODE
              if(this.currentTime.id === previousTimerId){
                  this.currentTime.id = emptyTimer.id
                  this.currentTime.project = emptyTimer.project
                  this.currentTime.description = emptyTimer.description
                  this.currentTime.key = emptyTimer.key
              }
            }
          }
          this.newIssue = ''
          this.isNewTask = false
          this.changeState = true
        })
        // response to validate-issue, fail and show message to end-user
        ipcRenderer.on('validate-issue-error', (event, arg) => {
          this.isNewTask = false
          this.newIssue = ''
          console.log(arg)
          let self = this
          switch (arg.status){
            case 401:
                self.error.show = true
                self.error.message = 'Unauthorized access'
                break
            default:
                if(arg.data.hasOwnProperty('errorMessages')){
                    self.error.message = arg.data.errorMessages[0];
                }else{
                    self.error.message = 'Failed to connect with JIRA';
                }
                self.error.show = true

          }
          setTimeout(function () {
            if (self.error.show === true) { self.error.show = false }
          }, 2000)
        })
      }
    }
</script>


<style scoped lang="scss">
    @import url('https://fonts.googleapis.com/css?family=Roboto:300,400');

    //Imports
    $red-color: #ef5f59;
    $roboto: 'Roboto', sans-serif;

    textarea:focus, input:focus{
        outline: none;
    }
    .without::-webkit-datetime-edit-ampm-field {
        display: none;
    }

    .active-edit{
        top:-110px!important;
    }

    .active-empty{
        top:0!important;
    }

    .active-message{
        bottom:0 !important;
        transition: linear .5s;
    }

    .active-task{
        bottom:50px !important;
        transition: linear .5s;
    }

    .text{
        font-family: $roboto;
        font-size: 16px;
        color:#888;
    }
    .regular{
        font-family: $roboto;
        font-size: 14px;
        color:#888;
        margin:0;
    }
    .small{
        font-family: $roboto;
        font-size: 12px;
        color:#888;
        margin:0;
    }
    .timer-app {
        width: 100%;
        height: 100vh;
        background: $red-color;
        color: white;
        overflow-y: hidden;
    }
    .app-header{
        height:200px;
        position: relative;
        overflow: hidden;
        .top-app{
            width: 100%;
            height: 50px;
            line-height: 50px;
            text-align: center;
            box-shadow: 0 2px 5px -1px rgba(80, 79, 79, 0.75);
            position:relative;
            display: flex;
            justify-content: space-between;
            align-items: center;
            h1.title{
                font-family: $roboto;
                font-weight: 500;
                font-size: 18px;
                margin: 0;
            }
            span{
                font-size: 22px;
                color:#FFF;
                width: 45px;
                text-align: center;
                display: inline-block;
                &:hover{
                    color:#FEE;
                    cursor: pointer;
                    transition:all .3s;
                }

            }
        }
        .timer-container{
            width: 100%;
            height: 150px;
            text-align: center;
            font-size: 3.5em;
            .top{
                display: flex;
                justify-content: space-between;
                align-items: center;
                height: 100px;
                span{
                    width:25%;
                    display: inline-block;
                    font-size: 30px;
                    &:before{
                        transition: all 2s;
                    }
                    &:hover{
                        color:#FEE;
                        cursor: pointer;
                        transition:all .3s;
                    }
                }
                label{
                    width: 50%;
                    display: inline-block;
                }
            }
            .current-task{
                position: relative;
                height: 50px;
                color: #FFF;
                h2{
                    margin: 0;
                    padding: 0;
                    line-height: 20px;
                    font-size: 16px;
                }
                img{
                    position: absolute;
                    height: 20px;
                    top: -20px;
                    left: 183px;
                }
            }
        }
    }
    .info-messages{
        width: 100%;
        height: 25px;
        position: absolute;
        bottom:-26px;
        background: lighten(#eee,5%);
        border-bottom: 1px solid #eee;
        text-align: center;
        transition:all .5s;
        p{
            line-height: 25px;
            @extend .regular;
        }
    }
    .app-tasks {
        width: 100%;
        height: 100%;
        min-height: 210px;
        background: white;

        .task-grid{
            overflow-y: scroll;
            overflow-x: hidden;
            height: 210px;
            &::-webkit-scrollbar-track {

                background-color: #FFF;
            }

            &::-webkit-scrollbar {
                width: 8px;
                background-color: #F5F5F5;
            }

            &::-webkit-scrollbar-thumb {

                background-color: lighten(#ddd,10%);
            }
            .task-item{
                width: 100%;
                height: 55px;
                overflow: hidden;
                position: relative;
                border-bottom:1px solid rgba(#DDD,.5%);
                .task-container{
                    position: absolute;
                    top: -55px;
                    width: 100%;
                    height: 55px;
                    transition: all .5s;
                    .item-container{
                        display: flex;
                        align-items: center;
                        width: 100%;
                        height: 55px;
                        padding: 0 5px;
                        .col-left{
                            width: 80%;
                            h3.task-id{
                                @extend .regular;
                            }
                            h2.task-name{
                                @extend .regular;
                            }
                        }
                        .col-right{
                            width: 20%;
                            display: flex;
                            flex-direction: column;
                            align-items: center;
                            span.current-time{
                                @extend .small;
                            }
                            span.start-task{
                                color:#888;
                                cursor: pointer;
                            }
                        }
                        .col-left-edit{
                            width: 55%;
                            h3.task-id{
                                @extend .regular;
                            }
                            h2.task-name{
                                @extend .regular;
                            }

                        }
                        .col-right-edit{
                            width: 40%;
                            display: flex;
                            flex-direction: row;
                            justify-content: space-around;
                            align-items: center;
                            div{
                                border: 1px solid #d4cdcd;
                                border-radius: 5px;
                                width: 60%;
                                text-align: center;
                            }
                            input{
                                width:40%;
                                text-align: center;
                                height: 25px;
                                border:none;
                            }
                            span.separator{
                                color: #888;
                            }
                            span.start-task{
                                color:#888;
                                cursor: pointer;
                            }
                        }
                        .col-left-empty{
                            width: 80%;display: flex;
                            justify-content: space-around;
                            h3{
                                @extend .regular;
                            }
                            .empty-option{
                                text-decoration: underline;
                                cursor: pointer;
                            }
                            .empty-separator{
                                font-weight:100;
                            }

                        }
                    }
                }

            }

        }
    }
    .app-footer{
        width: 100%;
        height: 50px;
        background: lighten(#eee,5%);
        position: fixed;
        bottom: 0;
        display: flex;
        align-items: center;
        color: black;
        justify-content: space-between;
        font-size: 14px;
        line-height: 50px;
        .entry{
            width: 70px;
            height: 35px;
            @extend .text;
            display: flex;
            align-items: center;
            justify-content: center;
            transition:all .3s;
            &:hover{
                color:lighten(#888,10%);
                cursor: pointer;
                transition:all .3s;
            }


            &::before{
                font-family: "timer";
                font-size: 18px;
                color:#888;
                display: inline-block;

                position: relative;
                top: 2px;
                left: -1px;
            }
        }
        .time-elapsed{
            @extend .text;
            min-width: 100px;
            text-align: center;
        }
    }

    .app-new-task{
        width: 100%;
        height: 50px;
        display: flex;
        background: lighten(#eee,5%);
        position: absolute;
        bottom: 0;
        align-items: center;
        color: black;
        justify-content: space-between;
        font-size: 14px;
        line-height: 50px;
        transition:all .5s;
        .empty-task-icon{
            position: absolute;
            cursor: pointer;
            right: 15px;
            @extend .text
        }
        .task-search-input {
            width: 80%;
            height: 50px;
            display: flex;
            bottom: 0;
            align-items: center;
            color: black;
            justify-content: flex-start;
            font-size: 14px;
            line-height: 50px;
            .entry{
                width: 80%;
                height: 35px;
                @extend .text;
                display: flex;
                align-items: center;
                justify-content: center;
                transition:all .3s;
                text-indent:5px;
                border: 1px solid lightgray;
                border-radius: 40px;
                &:hover{
                    color:lighten(#888,10%);
                    transition:all .3s;
                }
                &::before{
                    font-family: "timer";
                    font-size: 18px;
                    color:#888;
                    display: inline-block;

                    position: relative;
                    top: 2px;
                    left: -1px;
                }
            }
            .time-elapsed{
                @extend .text;
                min-width: 100px;
                text-align: center;
            }
            .entryLabel{
                max-width: 100px;
                width: 20%;
                position: relative;
                left: -30px;
                @extend .text;
            }
        }
    }
</style>
